!ABCIncludeFile

 OMIT('_EndOfInclude_',_CBCSGlobalPresent_)

_CBCSGlobalPresent_ EQUATE(1)

CBCSGlobalClass    CLASS,TYPE,MODULE('CBCSGlobal.CLW'),LINK('CBCSGlobal.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
!CS                  &ICriticalSection,PRIVATE

!Construct           PROCEDURE()
!Destruct            PROCEDURE()
Wait                PROCEDURE()
Release             PROCEDURE()
GetIFace            PROCEDURE(),*ISyncObject  !For calling CriticalProcedure.Init(CSGlobal.GetIFace())

 !Let's say you have a critical section that you only want to creat when needed.
 !This creation could be happening in multiple thread so you need to protect that create code in a Critical section
 !The below two functions work as follows
 !1. The code they run is inside a private global CS so only one thread can be running it
 !2. If the ICriticalSection already exists it is not created again becuase it is assumed that another thread
 !     got there first and made it
 !3. The Dispose also runs inside a private CS and so it is assured that two threads cannot both do it

 !Example of the Init Use
 !  IF MyCS &= Null
 !     CSGlobal.SafeNewICriticalSection(MyCS)
 !  END

SafeNewCriticalSection      PROCEDURE(*ICriticalSection In_ICriticalSection),*ICriticalSection  !Pass in a CS and returns that or makes a NewOne
SafeDisposeCriticalSection  PROCEDURE(*ICriticalSection In_ICriticalSection),*ICriticalSection  !Pass in a CS, kills and returns NULL

!Clarion cannot have an In/Out *Class
!SafeNewICriticalSection  PROCEDURE(*ICriticalSection InOut_ICriticalSection),BYTE,PROC     !Returns 0=Ok, 1=Already Exists 2=Failed
!SafeDisposeICriticalSection  PROCEDURE(*ICriticalSection InOut_ICriticalSection),BYTE,PROC !Returns 0=Ok, 1=Didn't Exist 2=Failed
                  END



  _EndOfInclude_
